=== modified file 'drizzled/execute/parser.yy'
--- drizzled/execute/parser.yy	2011-06-30 08:09:25 +0000
+++ drizzled/execute/parser.yy	2011-10-06 18:18:31 +0000
@@ -1,5 +1,5 @@
 /*  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- * 
+ *
  *  Drizzle Execute Parser
  *
  *  Copyright (C) 2011 Data Differential, http://datadifferential.com/
@@ -71,7 +71,7 @@
 
 int execute_lex(YYSTYPE* lvalp, void* scanner);
 std::string query;
-#define parser_abort(A, B) do { parser::abort_func((A), (B)); YYABORT; } while (0) 
+#define parser_abort(A, B) do { parser::abort_func((A), (B)); YYABORT; } while (0)
 
 inline void execute_error(::drizzled::execute::Context *context, yyscan_t *scanner, const char *error)
 {
@@ -92,44 +92,40 @@
 
 %%
 
-begin:    
+begin:
 
-          STRING   {   
-                       query.append( std::string($1.str, $1.length));
+          STRING   {
+                       query.append($1.data(), $1.size());
                        query.push_back(' ');
                    }
           |
-                         
+
           begin STRING {
-                         query.append(std::string($2.str, $2.length));
+                         query.append($2.data(), $2.size());
                          query.push_back(' ');
                        }
         ;
 
 
-%% 
+%%
 
 
 namespace drizzled {
 namespace execute {
 
-std::vector<std::string> Context::start() 
+std::vector<std::string> Context::start()
 {
   execute_parse(this, (void **)scanner);
   std::vector<std::string> parsed_queries;
   while ((pos= query.find(';')) != std::string::npos)
   {
     parsed_queries.push_back(query.substr(0, pos));
-    if (query[pos+1] == ' ')
-    {
-      query= query.substr(pos + 2, query.length());
-    }
-    else
-    {
-      query= query.substr(pos + 1, query.length());
-    }
+    pos++;
+    if (query[pos] == ' ')
+    	pos++;
+    query.erase(0, pos);
   }
-  parsed_queries.push_back(query); 
+  parsed_queries.push_back(query);
   query.clear();
 
   return parsed_queries;

=== modified file 'drizzled/execute/scanner.l'
--- drizzled/execute/scanner.l	2011-06-04 15:46:01 +0000
+++ drizzled/execute/scanner.l	2011-10-06 18:18:31 +0000
@@ -124,8 +124,7 @@
 
 
 [[:punct:]]?{ALNUM}*["."{ALNUM}_-]*{ALNUM}*[[:punct:]]? {
-      yylval->string.str = yytext;
-      yylval->string.length = yyleng;
+      yylval->string.assign(yytext, yyleng);
       return STRING;
     }
 

=== modified file 'drizzled/foreign_key.cc'
--- drizzled/foreign_key.cc	2011-06-23 11:06:21 +0000
+++ drizzled/foreign_key.cc	2011-10-06 18:18:31 +0000
@@ -27,8 +27,7 @@
 #include <drizzled/internal/my_sys.h>
 #include <drizzled/table_ident.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 extern const charset_info_st *system_charset_info;
 
@@ -61,19 +60,19 @@
   pfkey->set_update_option(update_opt_arg);
   pfkey->set_delete_option(delete_opt_arg);
 
-  pfkey->set_references_table_name(table->table.str);
+  pfkey->set_references_table_name(table->table.data());
 
   Key_part_spec *keypart;
   List<Key_part_spec>::iterator col_it(cols.begin());
   while ((keypart= col_it++))
   {
-    pfkey->add_column_names(keypart->field_name.str);
+    pfkey->add_column_names(keypart->field_name.data());
   }
 
   List<Key_part_spec>::iterator ref_it(ref_cols.begin());
   while ((keypart= ref_it++))
   {
-    pfkey->add_references_columns(keypart->field_name.str);
+    pfkey->add_references_columns(keypart->field_name.data());
   }
 
 }
@@ -197,11 +196,11 @@
     it= table_fields.begin();
     while ((sql_field= it++) &&
            my_strcasecmp(system_charset_info,
-                         column->field_name.str,
+                         column->field_name.data(),
                          sql_field->field_name)) {}
     if (!sql_field)
     {
-      my_error(ER_KEY_COLUMN_DOES_NOT_EXITS, MYF(0), column->field_name.str);
+      my_error(ER_KEY_COLUMN_DOES_NOT_EXITS, MYF(0), column->field_name.data());
       return true;
     }
   }

=== modified file 'drizzled/function/get_system_var.cc'
--- drizzled/function/get_system_var.cc	2011-08-04 08:13:04 +0000
+++ drizzled/function/get_system_var.cc	2011-10-06 18:18:31 +0000
@@ -63,7 +63,7 @@
   sys_var *var;
   lex_string_t *base_name, *component_name;
 
-  if (component.str)
+  if (component.data())
   {
     base_name= &component;
     component_name= &name;
@@ -74,19 +74,18 @@
     component_name= &component;                 // Empty string
   }
 
-  if (!(var= find_sys_var(base_name->str)))
+  if (!(var= find_sys_var(base_name->data())))
     return 0;
-  if (component.str)
+  if (component.data())
   {
-    my_error(ER_VARIABLE_IS_NOT_STRUCT, MYF(0), base_name->str);
+    my_error(ER_VARIABLE_IS_NOT_STRUCT, MYF(0), base_name->data());
     return 0;
   }
   session->lex().setCacheable(false);
 
   set_if_smaller(component_name->length, (size_t)MAX_SYS_VAR_LENGTH);
 
-  return new Item_func_get_system_var(var, var_type, component_name,
-                                      NULL, 0);
+  return new Item_func_get_system_var(var, var_type, component_name, NULL, 0);
 }
 
 

=== modified file 'drizzled/function/get_user_var.cc'
--- drizzled/function/get_user_var.cc	2011-03-03 08:29:06 +0000
+++ drizzled/function/get_user_var.cc	2011-10-06 18:18:31 +0000
@@ -133,7 +133,7 @@
 void Item_func_get_user_var::print(String *str)
 {
   str->append(STRING_WITH_LEN("(@"));
-  str->append(name.str,name.length);
+  str->append(name);
   str->append(')');
 }
 
@@ -149,8 +149,8 @@
       ((Item_func*) item)->functype() != functype())
     return 0;
   Item_func_get_user_var *other=(Item_func_get_user_var*) item;
-  return (name.length == other->name.length &&
-	  !memcmp(name.str, other->name.str, name.length));
+  return (name.size() == other->name.size() &&
+	  !memcmp(name.data(), other->name.data(), name.size()));
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/function/set_user_var.cc'
--- drizzled/function/set_user_var.cc	2011-07-14 22:12:02 +0000
+++ drizzled/function/set_user_var.cc	2011-10-06 18:18:31 +0000
@@ -307,7 +307,7 @@
 void Item_func_set_user_var::print(String *str)
 {
   str->append(STRING_WITH_LEN("(@"));
-  str->append(name.str, name.length);
+  str->append(name);
   str->append(STRING_WITH_LEN(":="));
   args[0]->print(str);
   str->append(')');

=== modified file 'drizzled/function/user_var_as_out_param.cc'
--- drizzled/function/user_var_as_out_param.cc	2011-03-28 02:46:21 +0000
+++ drizzled/function/user_var_as_out_param.cc	2011-10-06 18:18:31 +0000
@@ -25,8 +25,7 @@
 #include <drizzled/user_var_entry.h>
 #include <drizzled/session.h>
 
-namespace drizzled
-{
+namespace drizzled {
 
 bool Item_user_var_as_out_param::fix_fields(Session *session, Item **ref)
 {
@@ -85,11 +84,10 @@
   return 0;
 }
 
-
 void Item_user_var_as_out_param::print(String *str)
 {
   str->append('@');
-  str->append(name.str,name.length);
+  str->append(name);
 }
 
 } /* namespace drizzled */

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2011-08-08 17:05:09 +0000
+++ drizzled/item/create.cc	2011-10-06 18:18:31 +0000
@@ -132,7 +132,7 @@
   {
     if (item_list && has_named_parameters(*item_list))
     {
-      my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.str);
+      my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
       return NULL;
     }
     return create_native(session, name, item_list);
@@ -1038,7 +1038,7 @@
 
 Item* Create_udf_func::create(Session *session, lex_string_t name, List<Item> *item_list)
 {
-  return create(session, plugin::Function::get(std::string(name.str, name.length)), item_list);
+  return create(session, plugin::Function::get(std::string(name.data(), name.size())), item_list);
 }
 
 Item* Create_udf_func::create(Session *session, const plugin::Function *udf, List<Item> *item_list)
@@ -1060,7 +1060,7 @@
 {
   if (item_list && item_list->size())
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
   return create(session);
@@ -1071,7 +1071,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count != 1)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1079,7 +1079,7 @@
 
   if (! param_1->is_autogenerated_name)
   {
-    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
     return NULL;
   }
 
@@ -1093,7 +1093,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count != 2)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1103,7 +1103,7 @@
   if (   (! param_1->is_autogenerated_name)
       || (! param_2->is_autogenerated_name))
   {
-    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
     return NULL;
   }
 
@@ -1117,7 +1117,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count != 3)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1129,7 +1129,7 @@
       || (! param_2->is_autogenerated_name)
       || (! param_3->is_autogenerated_name))
   {
-    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMETERS_TO_NATIVE_FCT, MYF(0), name.data());
     return NULL;
   }
 
@@ -1154,7 +1154,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count < 1)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1172,7 +1172,7 @@
   /* "WS" stands for "With Separator": this function takes 2+ arguments */
   if (arg_count < 2)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1231,7 +1231,7 @@
       return new (session->mem) Item_func_export_set(param_1, param_2, param_3, param_4, param_5);
     }
   default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
   return NULL;
 }
@@ -1246,7 +1246,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count < 2)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1301,7 +1301,7 @@
       return new (session->mem) Item_func_date_format(ut, param_2, 0);
     }
   default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
   return NULL;
 }
@@ -1316,7 +1316,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count < 2)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1377,7 +1377,7 @@
       return new (session->mem) Item_func_last_insert_id(param_1);
     }
   default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
   return NULL;
 }
@@ -1401,7 +1401,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count < 2)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1442,7 +1442,7 @@
       return new (session->mem) Item_func_locate(param_2, param_1, param_3);
     }
   default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
   return NULL;
 }
@@ -1456,7 +1456,7 @@
   int arg_count= item_list ? item_list->size() : 0;
   if (arg_count < 2)
   {
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
     return NULL;
   }
 
@@ -1528,7 +1528,7 @@
     return new (session->mem) Item_func_round(param_1, param_2, 0);
   }
   default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
   return NULL;
 }
@@ -1572,7 +1572,7 @@
   case 1:
     return new (session->mem) Item_func_unix_timestamp(item_list->pop());
   default:
-    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.str);
+    my_error(ER_WRONG_PARAMCOUNT_TO_FUNCTION, MYF(0), name.data());
   }
   return NULL;
 }
@@ -1666,7 +1666,7 @@
 
 Create_func* find_native_function_builder(lex_string_t name)
 {
-  return find_ptr2(FunctionContainer::getMap(), name.str);
+  return find_ptr2(FunctionContainer::getMap(), name.data());
 }
 
 Item* create_func_char_cast(Session *session, Item *a, int len, const charset_info_st* cs)

=== modified file 'drizzled/key.h'
--- drizzled/key.h	2011-08-03 10:04:55 +0000
+++ drizzled/key.h	2011-10-06 18:18:31 +0000
@@ -63,8 +63,7 @@
     columns(cols),
     generated(generated_arg)
   {
-    name.str= const_cast<char *>(name_arg);
-    name.length= name_len_arg;
+    name.assign(name_arg, name_len_arg);
   }
 
   virtual ~Key() {}

=== modified file 'drizzled/key_part_spec.h'
--- drizzled/key_part_spec.h	2011-07-25 14:24:19 +0000
+++ drizzled/key_part_spec.h	2011-10-06 18:18:31 +0000
@@ -34,7 +34,7 @@
   {}
   Key_part_spec(const char *name, const size_t name_len, uint32_t len)
     : length(len)
-  { field_name.str= const_cast<char *>(name); field_name.length= name_len; }
+  { field_name.assign(name, name_len); }
   bool operator==(const Key_part_spec& other) const;
   /**
     Construct a copy of this Key_part_spec. field_name is copied

=== modified file 'drizzled/lex_string.h'
--- drizzled/lex_string.h	2011-08-05 09:43:18 +0000
+++ drizzled/lex_string.h	2011-10-06 18:18:31 +0000
@@ -40,6 +40,28 @@
     return str + length;
   }
 
+  const char* data() const
+  {
+    return str;
+  }
+
+  size_t size() const
+  {
+    return length;
+  }
+
+  void assign(const char* d, size_t s)
+  {
+    str= const_cast<char*>(d);
+    length = s;
+  }
+
+  void assign(char* d, size_t s)
+  {
+    str= d;
+    length = s;
+  }
+
   char* str;
   size_t length;
 };
@@ -61,11 +83,10 @@
     return is_variable;
   }
 
-  void set(const lex_string_t& ptr, bool is_variable_arg= false)
+  void set(const lex_string_t& s, bool is_variable_arg= false)
   {
     is_variable= is_variable_arg;
-    str= ptr.str;
-    length= ptr.length;
+    static_cast<lex_string_t&>(*this) = s;
   }
 
 };

=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-09-19 09:17:51 +0000
+++ drizzled/parser.cc	2011-10-06 18:18:31 +0000
@@ -223,9 +223,9 @@
 
 bool check_reserved_words(lex_string_t *name)
 {
-  if (!my_strcasecmp(system_charset_info, name->str, "GLOBAL") ||
-      !my_strcasecmp(system_charset_info, name->str, "LOCAL") ||
-      !my_strcasecmp(system_charset_info, name->str, "SESSION"))
+  if (!my_strcasecmp(system_charset_info, name->data(), "GLOBAL") ||
+      !my_strcasecmp(system_charset_info, name->data(), "LOCAL") ||
+      !my_strcasecmp(system_charset_info, name->data(), "SESSION"))
     return true;
 
   return false;
@@ -305,7 +305,7 @@
 {
   message::Engine::Option *opt= lex->table()->mutable_engine()->add_options();
   opt->set_name(key);
-  opt->set_state(value.str, value.length);
+  opt->set_state(value.data(), value.size());
 }
 
 void buildEngineOption(LEX *lex, const char *key, uint64_t value)
@@ -320,13 +320,13 @@
   statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
   message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
   opt->set_name(key);
-  opt->set_state(value.str, value.length);
+  opt->set_state(value.data(), value.size());
 }
 
 void buildSchemaDefiner(LEX *lex, const lex_string_t &value)
 {
   statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
-  identifier::User user(value.str);
+  identifier::User user(value.data());
   message::set_definer(statement->schema_message, user);
 }
 
@@ -348,19 +348,19 @@
 {
   TableList *table= reinterpret_cast<TableList*>(lex->current_select->table_list.first);
 
-  if (schema_name.length)
+  if (schema_name.size())
   {
-    if (my_strcasecmp(table_alias_charset, schema_name.str, table->getSchemaName()))
+    if (my_strcasecmp(table_alias_charset, schema_name.data(), table->getSchemaName()))
     {
-      my_error(ER_WRONG_DB_NAME, MYF(0), schema_name.str);
+      my_error(ER_WRONG_DB_NAME, MYF(0), schema_name.data());
       return false;
     }
   }
 
-  if (my_strcasecmp(table_alias_charset, table_name.str,
+  if (my_strcasecmp(table_alias_charset, table_name.data(),
                     table->getTableName()))
   {
-    my_error(ER_WRONG_TABLE_NAME, MYF(0), table_name.str);
+    my_error(ER_WRONG_TABLE_NAME, MYF(0), table_name.data());
     return false;
   }
 
@@ -371,22 +371,21 @@
 {
   Select_Lex *sel= lex->current_select;
 
-  if (table_name.length and sel->no_table_names_allowed)
+  if (table_name.size() and sel->no_table_names_allowed)
   {
-    my_error(ER_TABLENAME_NOT_ALLOWED_HERE, MYF(0), table_name.str, lex->session->where());
+    my_error(ER_TABLENAME_NOT_ALLOWED_HERE, MYF(0), table_name.data(), lex->session->where());
   }
 
   return sel->parsing_place != IN_HAVING || sel->get_in_sum_expr() > 0
-    ? (Item*) new Item_field(lex->current_context(), schema_name.str, table_name.str, field_name.str) 
-    : (Item*) new Item_ref(lex->current_context(), schema_name.str, table_name.str, field_name.str);
+    ? (Item*) new Item_field(lex->current_context(), schema_name.data(), table_name.data(), field_name.data()) 
+    : (Item*) new Item_ref(lex->current_context(), schema_name.data(), table_name.data(), field_name.data());
 }
 
 Item *buildTableWild(LEX *lex, const lex_string_t &schema_name, const lex_string_t &table_name)
 {
   Select_Lex *sel= lex->current_select;
-  Item *item= new Item_field(lex->current_context(), schema_name.str, table_name.str, "*");
+  Item *item= new Item_field(lex->current_context(), schema_name.data(), table_name.data(), "*");
   sel->with_wild++;
-
   return item;
 }
 

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-09-26 15:02:54 +0000
+++ drizzled/session.cc	2011-10-06 18:18:31 +0000
@@ -103,8 +103,8 @@
 bool Key_part_spec::operator==(const Key_part_spec& other) const
 {
   return length == other.length &&
-         field_name.length == other.field_name.length &&
-    !my_strcasecmp(system_charset_info, field_name.str, other.field_name.str);
+         field_name.size() == other.field_name.size() &&
+    !my_strcasecmp(system_charset_info, field_name.data(), other.field_name.data());
 }
 
 Open_tables_state::Open_tables_state(Session& session, uint64_t version_arg) :
@@ -862,8 +862,7 @@
 {
   if (not lex_str)
     lex_str= new (mem) lex_string_t;
-  lex_str->str= mem_root->strdup(str);
-  lex_str->length= str.size();
+  lex_str->assign(mem_root->strdup(str), str.size());
   return lex_str;
 }
 
@@ -1693,7 +1692,7 @@
 
 user_var_entry *Session::getVariable(lex_string_t &name, bool create_if_not_exists)
 {
-  return getVariable(std::string(name.str, name.length), create_if_not_exists);
+  return getVariable(std::string(name.data(), name.size()), create_if_not_exists);
 }
 
 user_var_entry *Session::getVariable(const std::string  &name, bool create_if_not_exists)

=== modified file 'drizzled/show.cc'
--- drizzled/show.cc	2011-08-04 08:13:04 +0000
+++ drizzled/show.cc	2011-10-06 18:18:31 +0000
@@ -286,15 +286,15 @@
   util::string::ptr schema(session->schema());
   if (schema_ident)
   {
-    select->setShowPredicate(schema_ident, table_ident->table.str);
+    select->setShowPredicate(schema_ident, table_ident->table.data());
   }
-  else if (table_ident->db.str)
+  else if (table_ident->db.data())
   {
-    select->setShowPredicate(table_ident->db.str, table_ident->table.str);
+    select->setShowPredicate(table_ident->db.data(), table_ident->table.data());
   }
   else if (schema)
   {
-    select->setShowPredicate(*schema, table_ident->table.str);
+    select->setShowPredicate(*schema, table_ident->table.data());
   }
   else
   {
@@ -303,7 +303,7 @@
   }
 
   {
-    drizzled::identifier::Table identifier(select->getShowSchema(), table_ident->table.str);
+    drizzled::identifier::Table identifier(select->getShowSchema(), table_ident->table.data());
     if (not plugin::StorageEngine::doesTableExist(*session, identifier))
     {
       my_error(ER_TABLE_UNKNOWN, identifier);
@@ -349,15 +349,15 @@
   util::string::ptr schema(session->schema());
   if (schema_ident)
   {
-    select->setShowPredicate(schema_ident, table_ident->table.str);
+    select->setShowPredicate(schema_ident, table_ident->table.data());
   }
-  else if (table_ident->db.str)
+  else if (table_ident->db.data())
   {
-    select->setShowPredicate(table_ident->db.str, table_ident->table.str);
+    select->setShowPredicate(table_ident->db.data(), table_ident->table.data());
   }
   else if (schema)
   {
-    select->setShowPredicate(*schema, table_ident->table.str);
+    select->setShowPredicate(*schema, table_ident->table.data());
   }
   else
   {
@@ -366,7 +366,7 @@
   }
 
   {
-    drizzled::identifier::Table identifier(select->getShowSchema(), table_ident->table.str);
+    drizzled::identifier::Table identifier(select->getShowSchema(), table_ident->table.data());
     if (not plugin::StorageEngine::doesTableExist(*session, identifier))
     {
       my_error(ER_TABLE_UNKNOWN, identifier);
@@ -413,13 +413,13 @@
     return false;
 
   util::string::ptr schema(session->schema());
-  if (ident->db.str)
+  if (ident->db.data())
   {
-    select->setShowPredicate(ident->db.str, ident->table.str);
+    select->setShowPredicate(ident->db.data(), ident->table.data());
   }
   else if (schema)
   {
-    select->setShowPredicate(*schema, ident->table.str);
+    select->setShowPredicate(*schema, ident->table.data());
   }
   else
   {
@@ -489,9 +489,9 @@
     return false;
 
   util::string::ptr schema(session->schema());
-  if (ident.str)
+  if (ident.data())
   {
-    select->setShowPredicate(ident.str);
+    select->setShowPredicate(ident.data());
   }
   else if (schema)
   {
@@ -526,13 +526,13 @@
   session->lex().select_lex.db= 0;
 
   util::string::ptr schema(session->schema());
-  if (ident->db.str)
+  if (ident->db.data())
   {
-    select->setShowPredicate(ident->db.str, ident->table.str);
+    select->setShowPredicate(ident->db.data(), ident->table.data());
   }
   else if (schema)
   {
-    select->setShowPredicate(*schema, ident->table.str);
+    select->setShowPredicate(*schema, ident->table.data());
   }
   else
   {
@@ -541,7 +541,7 @@
   }
 
   {
-    drizzled::identifier::Table identifier(select->getShowSchema(), ident->table.str);
+    drizzled::identifier::Table identifier(select->getShowSchema(), ident->table.data());
     if (not plugin::StorageEngine::doesTableExist(*session, identifier))
     {
       my_error(ER_TABLE_UNKNOWN, identifier);

=== modified file 'drizzled/table_ident.h'
--- drizzled/table_ident.h	2011-08-05 09:43:18 +0000
+++ drizzled/table_ident.h	2011-10-06 18:18:31 +0000
@@ -42,7 +42,7 @@
   explicit Table_ident(lex_string_t table_arg)
     : table(table_arg), sel(NULL)
   {
-    db.str= 0;
+    db.assign(static_cast<const char*>(NULL), 0);
   }
 
   /*
@@ -54,10 +54,8 @@
   explicit Table_ident(Select_Lex_Unit *s) : sel(s)
   {
     /* We must have a table name here as this is used with add_table_to_list */
-    db.str= const_cast<char*>("");                    /* a subject to casedn_str */
-    db.length= 0;
-    table.str= const_cast<char*>("*");
-    table.length= 1;
+    db.assign("", 0); // a subject to casedn_str
+    table.assign("*", 1);
   }
   bool is_derived_table() const { return test(sel); }
 };

=== modified file 'drizzled/table_proto.cc'
--- drizzled/table_proto.cc	2011-09-19 09:31:36 +0000
+++ drizzled/table_proto.cc	2011-10-06 18:18:31 +0000
@@ -404,7 +404,7 @@
   {
     message::Table::Index *idx= table_proto.add_indexes();
 
-    assert(test(key_info[i].flags & HA_USES_COMMENT) == (key_info[i].comment.length > 0));
+    assert(test(key_info[i].flags & HA_USES_COMMENT) == (key_info[i].comment.size() > 0));
 
     idx->set_name(key_info[i].name);
     idx->set_key_length(key_info[i].key_length);
@@ -459,20 +459,19 @@
     {
       uint32_t tmp_len;
       tmp_len= system_charset_info->cset->charpos(system_charset_info,
-						  key_info[i].comment.str,
-						  key_info[i].comment.str +
-						  key_info[i].comment.length,
+						  key_info[i].comment.begin(),
+						  key_info[i].comment.end(),
 						  TABLE_COMMENT_MAXLEN);
 
-      if (tmp_len < key_info[i].comment.length)
+      if (tmp_len < key_info[i].comment.size())
       {
 	my_error(ER_WRONG_STRING_LENGTH, MYF(0),
-		 key_info[i].comment.str,"Index COMMENT",
+		 key_info[i].comment.data(), "Index COMMENT",
 		 (uint32_t) TABLE_COMMENT_MAXLEN);
 	return true;
       }
 
-      idx->set_comment(key_info[i].comment.str);
+      idx->set_comment(key_info[i].comment.data());
     }
     static const uint64_t unknown_index_flag= (HA_NOSAME | HA_PACK_KEY |
                                                HA_USES_BLOCK_SIZE | 

=== modified file 'drizzled/user_var_entry.h'
--- drizzled/user_var_entry.h	2011-08-03 10:04:55 +0000
+++ drizzled/user_var_entry.h	2011-10-06 18:18:31 +0000
@@ -38,13 +38,12 @@
     unsigned_flag(false),
     collation(NULL, DERIVATION_IMPLICIT)
   { 
-    name.str= strdup(arg);
-    name.length= strlen(arg);
+    name.assign(strdup(arg), strlen(arg));
   }
 
   ~user_var_entry()
   {
-    free(const_cast<char*>(name.str));
+    free(const_cast<char*>(name.data()));
     free(value);
   }
 

